
%%
%close all;
%%
clear;
%
%
prefix     = 'common_funlinkage';
source_str = 'tcga';
test_str   = 'bono';
alpha      = '0.50';
k          = 1;
%
%
%
source = sprintf('%s_%s',prefix,source_str);
test   = sprintf('%s_%s',prefix,test_str);
%
type_vec(1) = struct;
type_vec(1).id = sprintf('%s-%s',source,test);
type_vec(1).name = 'Co-expression';

%type_vec(2).id = 'funlinkage';
%type_vec(2).name = 'Functional Linkage';

bta_names = struct;

bta_names(1).id = 'l00';
bta_names(1).name = 'L1';
bta_names(1).dep = 0;

bta_names(2).id = 'l10';
bta_names(2).name = 'L2';
bta_names(2).dep = 0;

bta_names(3).id = 'nco';
bta_names(3).name = 'NetCox';
bta_names(3).dep = 1;

bta_names(4).id = 'dco';
bta_names(4).name = 'DegreeCox';
bta_names(4).dep = 1;
%%

for i = 1:length(type_vec)
    %
    type      = type_vec(i).id;
    type_name = type_vec(i).name;
    for j = 1:length(bta_names)
        bta      = bta_names(j).id;
        bta_name = bta_names(j).name;
        if bta_names(j).dep == 0 && i > 1
            
        else
            
            %
            model = bta;
            load( sprintf('data/results/survival/survival_groups-%s-%s-%dk-%salpha.mat',type,model,k,alpha));
            %
            h = figure;
            p = calc_logrank_dir( my_x1, my_x2, 1 );
            ylim([0 1.05]);
            mytitle = '';
            if bta_names(j).dep
                mytitle = sprintf('%s (%s) - %dK-fold',bta_name, type_name,k);
            else
                mytitle = sprintf('%s - %dK-fold',bta_name,k);
            end
            title(mytitle,'FontSize',14,'FontName','Courier');

            xmax = max(xlim);
            
            text('Position',[xmax *.5,0.735],'String',sprintf('p-value = %.3E',p),'BackgroundColor','w');

            pos = get(gcf,'Position');
            pos(3) = 461;
            pos(4) = 329;
            set(h,'Position',pos);
            set(gcf,'PaperSize',[10 12]);
            set(gcf, 'PaperPosition', [0 0 10 12]);
            
            print( h, ['data/imgs/',mytitle,'.eps'], '-depsc','-r300');
            %saveas( h, ['data/imgs/',mytitle,'.eps'], 'epsc');
        end
    end
end
