%% Net-Cox with co-expression network
clc
clear
%
collections = {'common_funlinkage'};
types       = {'tothill','tcga','bono'};
types       = {'tcga','bono'};
k_vec     = [1,5]; % k-fold crossvalidation
%%
for p = 1:length(collections)
    datacol = collections{p};
    for h = 1:length(types)
        dataset = types{h};
        load(sprintf('data/generated_source/%s_%s.mat',datacol,dataset));
        %
        Data     = mydata.Data_N;
        Times    = mydata.Times;
        d        = mydata.d;
        GeneName = mydata.GeneName;
        S_main   = mydata.S;
        %
        for k = k_vec

            rng(1985);
            indices = crossvalind('Kfold',size(Data,2),k);
            %%
            for i = 1:k
                idx_test  = (indices == i);
                if k == 1
                    idx_train = idx_test;
                    idx_test  = ~idx_train;
                else
                    idx_train = ~idx_test;
                end
                %
                % Get the Data (training and test)
                DataTrain = Data(:,idx_train);
                DataTest  = Data(:,idx_test);
                %
                % Calculate the co-expression network.
                fprintf('calculating funlinkage network for ''%s'' of ''%s''... (%0.2d/%0.2d)\n',datacol, dataset, i,k);
                fprintf('  Train set..\n');
                S_train = S_main;
                fprintf('  Test set..\n');
                S_test  = S_main;
                %
                fprintf('  Saving the data...\n');
                % ydata   = [Times(idx_train),d(idx_train)];
                % xdata   = DataTrain;
                S = S_train;
                save(sprintf('data/train/%s_%s_%0.2dk_%0.2dg',datacol,dataset,k,i),'S','idx_train','idx_test','i');
                %
                % ydata  = [Times(idx_test),d(idx_test)];
                % xdata  = DataTest;
                S = S_test;
                save(sprintf('data/test/%s_%s_%0.2dk_%0.2dg',datacol,dataset,k,i),'S','idx_train','idx_test','i');
                clear S idx
            end
        end
    end
end
