%%
clc;
clear;
warning 'off';

r00_my_config;
%
base_dir = 'data/train';
folder = params.folder;
%
k_vec = [1,5];

data_prefix_vec = params.joint_names;
%data_prefix_vec = {...
%    'common_funlinkage_bono', ...
%    'common_funlinkage_tcga', ...
%    'common_tothill', ...
%    'common_funlinkage_tothill'...
%};

reg_list = params.reg_list;
reg_list = {'degree','netcox'};

%data_prefix_vec = { 'common_tcga' };
%
for rr = 1:length(reg_list)
    reg_type = reg_list{rr};
    fprintf('Running for: %s and saving in folder: %s\n', reg_type, folder);
    for jj = 1:length(data_prefix_vec)
        for k = k_vec
            data_prefix = sprintf('%s_%0.2dk',data_prefix_vec{jj},k);
            %
            data_full = sprintf('data/generated_source/%s.mat', data_prefix_vec{jj});
            load(data_full);
            %
            files = dir(sprintf('%s/%s_*g.mat',base_dir,data_prefix));
            myrun = struct();
            %%
            mydat = struct;
            idx   = zeros(1,length(files));
            for file = files'
                fprintf('  loading ''%s''...\n', file.name);
                load(sprintf('%s/%s',base_dir,file.name));
                mydat(i).idx_train = idx_train;
                mydat(i).idx_test  = idx_test;
		mydat(i).xdata     = mydata.Data_N(:,idx_train);
		mydat(i).ydata     = [mydata.Times(idx_train), mydata.d(idx_train)];
                mydat(i).S         = S;
                mydat(i).filename  = file.name;
                %
                idx(i) = i;
                clear idx_train idx_test xdata ydata S
            end

            for idx_i = idx

                % parameter lambda balance the total likelihood and the network constraint, the larger the lambda the
                % more weight on the network constraint
                %
                % params.lam_max = 1e-4;
                % params.lam_rat = 0.05;
                % params.lambda  = linspace(params.lam_max, params.lam_rat * params.lam_max, params.nlambda);
                % params.lambda = sort(unique([params.lambda,1e-5,1e-4,1e-3,1e-2,1e-1,1e-0]));
                %
                % alpha weighting the network matrix and the identity matrix in the network
                % constraint, the smaller the alpha, the more we trust on network
                % information. alpha should belong to (0,1].
                %
                %% calculate
                %
                myrun(idx_i).idx_train = mydat(idx_i).idx_train;
                myrun(idx_i).idx_test  = mydat(idx_i).idx_test;
                %
                if strcmp('netcox', reg_type)
                    S = mydat(idx_i).S;
                    S(S < 0.0001) = 0;
                    %
                    myrun(idx_i).alpha_nc  = params.alpha_nc;
                    % myrun(idx_i).lambda_nc = sort([1e-05, 2.7265e-06, 7e-07]);
                    myrun(idx_i).lambda_nc = params.lambda_nc;
                    fprintf('    running    NetCox... (%s)\n', mydat(idx_i).filename);
                    myrun(idx_i).beta_nc =           NetCox( mydat(idx_i).xdata, myrun(idx_i).lambda_nc, myrun(idx_i).alpha_nc, mydat(idx_i).ydata(:,2), S);
                elseif strcmp('degree', reg_type)
                    % laplacian matrix
                    %    L = (1-alpha(nn))*(eye(m) - S) + alpha(nn)*eye(m);
                    S = mydat(idx_i).S;
                    L = sum(S);
                    L = 1 ./ L;
                    L = L ./ max(L);
                    L(L==Inf) = 0;
                    L= diag(L);
                    %
                    myrun(idx_i).alpha_dc  = params.alpha_dc;
                    myrun(idx_i).lambda_dc  = params.lambda_dc;
                    fprintf('  running DegreeCox... (%s)\n', mydat(idx_i).filename);
                    myrun(idx_i).beta_dc =   DegreeNetCox( mydat(idx_i).xdata, myrun(idx_i).lambda_dc, mydat(idx_i).ydata(:,2), L);
                end
            end
            %
            %% save the data
            mkdir(sprintf('data/results/%s', folder));
            save_file = sprintf('data/results/%s/%s_%s.mat', folder, data_prefix, reg_type);
	    fprintf('saving data in "%s"\n', save_file);
	    save(save_file, 'myrun');
            disp('done!');
        end
    end
end
