clear

r00_my_config;
folder = params.folder';
single = 0; % if using old system of single myrun

dest = sprintf('data/results/%s/determine_btas/', folder);
mkdir(dest);
%%
mytype_list = {'common_funlinkage', 'common'};
mytype_output = {'funlinkage','correlation'};
%
for jx = 1:length(mytype_list)
    % load original data
    load(sprintf('data/generated_source/%s_%s.mat', mytype_list{jx}, 'bono'));
    genename = mydata.GeneName;
    filepath = sprintf('%s%s_genes_name.mat', dest, mytype_output{jx});
    fprintf('saving gene names (%d) to: %s\n', length(genename), filepath);
    save(filepath, 'genename');
end

%%

mycvp_num = '05k';
mytype_list = {...
    'common_bono', 'common_tcga',...
    'common_funlinkage_bono', 'common_funlinkage_tcga',...
    'common_tothill', 'common_funlinkage_tothill'    
    };
%mytype_list = {'common_tcga'};

best_lambdas = struct;

k = 1;

for jx = 1:length(mytype_list)
    mytype_name = mytype_list{jx};

    disp(mytype_name)
    best_lamdas.(mytype_name) = struct;

    myfields_name = {'dc', 'nc'};
    mylambdas = cell(1,length(myfields_name));
    myfields  = cell(1,length(myfields_name));

    for ix = 1:length(myfields)
       mylambdas{ix} = strcat('lambda_', myfields_name{ix});
       myalphas{ix} = strcat('alpha_', myfields_name{ix});
       myfields{ix}  = strcat('beta_', myfields_name{ix});
    end

    mytype = sprintf('%s_0%dk.mat', mytype_name, k);
    mycvp = sprintf('cvp_%s.mat', mycvp_num);

    % load original data
    load(sprintf('data/generated_source/%s.mat', mytype_name));
    % load r_results
    load(sprintf('data/results/r_results/r_results_%s', mytype));
    % load cross validation data
    load(sprintf('data/results/%s/%s', folder, mycvp));
    % load results
    res = struct();

    for ix = 1:length(myfields_name)
        %
	if single
            load(sprintf('data/results/%s/%s_0%dk.mat', folder, mytype_name, k));
	else
	     if strcmp(myfields_name{ix},'nc')
        	    load(sprintf('data/results/%s/%s_0%dk_netcox.mat', folder, mytype_name, k));
       	     elseif strcmp(myfields_name{ix},'dc')
       	           load(sprintf('data/results/%s/%s_0%dk_degree.mat', folder, mytype_name, k));
	     end
	end
        %
        name = myfields{ix};
        fprintf('  saving for: %s\n',name)
        cols = getfield(best_idx, mytype_name, name, 'col');
        rows = getfield(best_idx, mytype_name, name, 'row');
        %
        %
	for kix = 1:k
            res(kix).(name).lambda = best_idx.(mytype_name).(name).lambda(1);
            hasAlpha = 0;
            if isfield(best_idx.(mytype_name).(name), 'alpha')
                res(kix).(name).alpha  = best_idx.(mytype_name).(name).alpha(1);
                hasAlpha = 1;
            end
            lambda_ix = find(myrun(kix).(mylambdas{ix}) == res(kix).(name).lambda);
            lambda_ix = lambda_ix(1);
            fprintf('    lambda: %f\t', res(kix).(name).lambda);
            if hasAlpha
                alpha_ix = find(myrun(kix).(myalphas{ix}) == res(kix).(name).alpha);
                alpha_ix = alpha_ix(1);	
                fprintf(' alpha: %f', res(kix).(name).alpha);
            else
                alpha_ix = 1;
            end
            %
            btas = myrun(kix).(name);
	    %
            len = size(btas, 3);
            btas = btas(lambda_ix,alpha_ix,:);
            res(kix).(name).btas = reshape(btas, [1,len]);
	    fprintf('\t min bta = %f | max bta = %f\n', min(res(kix).(name).btas), max(res(kix).(name).btas));
        end
    end
    %
    % for GLMNET data ridge
    name = 'beta_gl';
    
    fprintf('  saving for: ridge\n');
    for kix = 1:k

	    myrun(kix).lambda_gl = lambda_vec;
	    myrun(kix).alpha_gl  = alpha_vec;
	    myrun(kix).beta_gl   = reshape(r_results(kix,:,:,:),size(r_results,2),size(r_results,3),size(r_results,4));

	    temp_idx = find( best_idx.(mytype_name).beta_gl.alpha == 0 );
	    lambda_idx = best_idx.(mytype_name).beta_gl.row(temp_idx(1));
	    alpha_idx  = best_idx.(mytype_name).beta_gl.col(temp_idx(1));
	    res(kix).('ridge').lambda = best_idx.(mytype_name).beta_gl.lambda(lambda_idx);
	    res(kix).('ridge').alpha  = best_idx.(mytype_name).beta_gl.alpha(alpha_idx);
	    res(kix).('ridge').btas   = reshape(myrun(kix).beta_gl( lambda_idx, alpha_idx, :), [], 1)';
	    fprintf('    lambda: %f\t', res(kix).ridge.lambda);
	    fprintf(' alpha: %f', res(kix).ridge.alpha);
	    fprintf('\t max bta = %f | max bta = %f\n', min(res(kix).('ridge').btas), max(res(kix).('ridge').btas));
    end

    fprintf('  saving for: lasso\n')
    for kix = 1:k
	    temp_idx   = find( best_idx.(mytype_name).beta_gl.alpha == 1 );
	    lambda_idx = best_idx.(mytype_name).beta_gl.row(temp_idx(1));
	    alpha_idx  = best_idx.(mytype_name).beta_gl.col(temp_idx(1));
	    res(kix).('lasso').lambda = best_idx.(mytype_name).beta_gl.lambda(lambda_idx);
	    res(kix).('lasso').alpha  = best_idx.(mytype_name).beta_gl.alpha(alpha_idx);
	    res(kix).('lasso').btas   = reshape(myrun(kix).beta_gl( lambda_idx, alpha_idx, :), [], 1)';
	    fprintf('    lambda: %f\t', res(kix).lasso.lambda);
	    fprintf(' alpha: %f\t', res(kix).lasso.alpha);
	    fprintf(' features: %d', sum(res(kix).lasso.btas ~= 0));
	    fprintf('\t min bta = %f | max bta = %f\n', min(res(kix).('lasso').btas), max(res(kix).('ridge').btas));
    end
    %
    %
    %
    %
    xdata = mydata.Data;
    xdata_n = mydata.Data_N;
    ydata = [mydata.Times, mydata.d];
    %
    filepath = sprintf('%s%s_0%dk_res.mat', dest, mytype_name, k);
    fprintf('Saving data (%s) to: %s\n', mytype_name, filepath);
    save(filepath, 'res', 'xdata', 'xdata_n', 'ydata');
end
